#include <stdlib.h>

#include <iostream>
using namespace std;

#include "../syssoft_win32.cpp"

volatile int shared_data = 0;
Semaphore shared_data_lock(1,1);

unsigned int __stdcall Reader ( void *arg ) {
	int myid = 0;
	while (true) {
		shared_data_lock.P();
		// READ ACCESS
		shared_data++;
		if (shared_data == 1)
			cout << "i(" << &myid << ") am the first reader" << endl;
		else
			cout << shared_data << " reader are inside" << endl;
		shared_data--;
		shared_data_lock.V();
	}
}

unsigned int __stdcall Writer ( void *arg ) {
	int myid = 0;
	while (true) {
		shared_data_lock.P();
		shared_data++;
		if (shared_data == 1)
			cout << "i(" << &myid << ") am the only writer" << endl;
		else
			cout << "Oops. More than one process accessing shared data." << endl;
		shared_data--;
		shared_data_lock.V();
	}
}

class ThreadArray {
public:
	ThreadArray ( int p_threads, Thread_Main_T p_main );
	~ThreadArray ();

	uintptr_t run ( int which, void *arg ) {
		if ((0<=which) && (which<n_threads))
			return threads[which]->run(arg);
	};

	void run ( void *arg ) {
		for (int t=0; t<n_threads; t++)
			(void) threads[t]->run(arg);
	};

	void join ( int which ) {
		if ((0<=which) && (which<n_threads))
			threads[which]->join();
	};

	void join () {
		for (int t=0; t<n_threads; t++)
			threads[t]->join();
	};
	
	int get_thread_count () const {
		return n_threads;
	};

private:
	int n_threads;
	Thread **threads;
};

ThreadArray::ThreadArray ( int p_threads, Thread_Main_T p_main ) : n_threads(p_threads) {
	typedef Thread *Thread_Ptr_T; // Make Compiler happy :-)
	threads = new Thread_Ptr_T[n_threads];
	for (int t=0; t<n_threads; t++)
		threads[t] = new Thread(p_main);
};

ThreadArray::~ThreadArray () {
	for (int t=0; t<n_threads; t++)
		delete threads[t];
	delete [] threads;
}

int main ( int ac, char **av ) {
	if (ac != 3) {
		cout << "usage: " << av[0] << " <n_reader> <n_writer>" << endl;
		exit(0);
	}

	int n_reader = atoi(av[1]);
	int n_writer = atoi(av[2]);

	ThreadArray reader(n_reader,Reader);
	ThreadArray writer(n_writer,Writer);

	reader.run(0);
	writer.run(0);

	reader.join();
	writer.join();
}
